USE StackOverflow2010
GO
--Part of problem query #1
--Run with Stats and Execution Plan, record the pages read

SET STATISTICS IO ON;
SELECT u.Reputation
FROM Users AS u
WHERE u.DisplayName = 'user169867'








--Create covering index
CREATE NONCLUSTERED INDEX ix_DisplayName_Reputation 
ON Users(DisplayName) INCLUDE (Reputation) WITH (MAXDOP = 4)







--Rerun the query
SET STATISTICS IO ON;
SELECT u.Reputation
FROM Users AS u
WHERE u.DisplayName = 'user169867'






--Now, add in the second logical part, the JOIN



SELECT u.Reputation,p.Score
FROM Users AS u
JOIN Posts AS p ON p.OwnerUserId = u.Id
WHERE u.DisplayName = 'user169867'






--Create index on the JOIN
CREATE NONCLUSTERED INDEX ix_OwnerUserId_Score 
ON Posts(OwnerUserId) INCLUDE (Score) WITH (MAXDOP = 4)





--Rerun the query
SELECT u.Reputation,p.Score
FROM Users AS u
JOIN Posts AS p ON p.OwnerUserId = u.Id
WHERE u.DisplayName = 'user169867'
--cleanup
/*
DROP INDEX ix_DisplayName_Reputation on Users
*/