USE StackOverflow2010
GO

SET STATISTICS IO ON;
SELECT Reputation,DisplayName FROM Users
WHERE CreationDate > '2008-12-01'
and CreationDate < '2009-12-01'




CREATE NONCLUSTERED INDEX ix_CreationDate_Reputation on Users(CreationDate)
INCLUDE (Reputation) WITH (MAXDOP = 4)

--Step 2: Adding Location
SELECT Reputation FROM Users
WHERE CreationDate > '2008-12-01'
and CreationDate < '2009-12-01'
and Location = 'United States'


CREATE NONCLUSTERED INDEX ix_CreationDate_Location on Users(CreationDate,Location)
INCLUDE (Reputation) WITH (MAXDOP = 4)








---But can we do better? Yes
CREATE NONCLUSTERED INDEX ix_Location_CreationDate on Users(Location,CreationDate)
INCLUDE (Reputation) WITH (MAXDOP = 4)






--Knowing that, let's add the final part
SELECT Reputation FROM Users
WHERE CreationDate > '2008-12-01'
and CreationDate < '2009-12-01'
and Location = 'United States'
and DisplayName like '%user%'



CREATE NONCLUSTERED INDEX ix_Location_CreationDate_Display
 ON Users(Location,CreationDate,DisplayName)
 INCLUDE (Reputation)